TAG

C++

7 篇文章

题解-找出叠涂元素-哈希表,两种思路,在途中检查和在最后检查

Problem: 2661. 找出叠涂元素 思路:中途检查 解法 数据量不大,看着可以在每次涂色时候查询是否合法 但是每次都查询显然会超时,我们选择一个更有效的优化 已经说明各个数各不相同,不会出现一个格子被涂两遍的情况 我们用数组来记录每一行和每一列已经被涂的格子数量,就能知道这一行列是否被全涂满 时间复杂度: $O(m*n)$ 空间复杂度: $O(m*n)$ Code class Solution: def firstCompleteIndex(self, arr: List[int], mat: List[List[int]]) -> int: matMap={} m=len(mat) n=len(mat[0]) row=[0]*m col=[0]*n for i in range(m): for j in range(n): matMap[mat[i][j]]=(i,j) for index in range(len(arr)): num=arr[index] x,y=matMap[num] row[x]+=1 col[y]+=1 if row[x]==n or col[y]==m: return index return -1 思路:最后查询 解法 我们注意到当我们知道某一行的所有元素的时候,变相知道了这一行会被什么时候涂满,既这一行存在arr中最靠后的那个索引 所以我们的任务变成了寻找最先被涂满的行或者列 对arr进行hash,记录每个元素的具体位置,再遍历行列,在遍历过程中 行列取最大值表示让这一行填满最少需要的步数 res取上述的数的最小值 时间复杂度: $O(mn)$ 空间复杂度: $O(mn)$ Code class Solution { public: int firstCompleteIndex(vector<int>& arr, vector<vector<int>>& mat) { int res=arr.size(); unordered_map<int,int>hash; for (int i=0;i<arr.size();i++){ hash[arr[i]]=i; } for (int i=0;i<mat.size();i++){ int tmp=0; for (int j=0;j<mat[0].size();j++){ tmp=max(tmp,hash[mat[i][j]]); } res=min(res,tmp); } for (int j=0;j<mat[0].size();j++){ int tmp=0; for (int i=0;i<mat.size();i++){ tmp=max(tmp,hash[mat[i][j]]); } res=min(res,tmp); } return res; } }; class Solution: def firstCompleteIndex(self, arr: List[int], mat: List[List[int]]) -> int: res=len(arr) m=len(mat) n=len(mat[0]) arrLocation={} for i,a in enumerate(arr): arrLocation[a]=i for i in range(m): nowColNeedSteps=0 for j in range(n): nowColNeedSteps=max(nowColNeedSteps,arrLocation[mat[i][j]]) res=min(res,nowColNeedSteps) for j in range(n): nowRowNeedSteps=0 for i in range(m): nowRowNeedSteps=max(nowRowNeedSteps,arrLocation[mat[i][j]]) res=min(res,nowRowNeedSteps) return res

↗

题解-在二叉树中分配硬币-深度优先搜索,自底向上考虑

Problem: 979. 在二叉树中分配硬币 思路 考虑最后计算成本的时候实际上是计算的是每个节点对硬币的操作数 每个节点只需要一个硬币,如何确定多出来的或少的硬币的流向 考虑自底向上,叶子节点只需要一个硬币,这样就能向父节点要硬币或者向父节点送硬币,之后父节点变成了叶子节点(其子节点已完成使命) 设一个值为$Need$表示需要向上移或者向上要的硬币数,根据以上推论我们能够得到如下公式,正数表示需要向上移动,负数表示需要上方向下移动 $$Need_{节点}=Need_{子节点}+val-1$$ 每次将一个节点处理完就将Need的绝对值加入到操作数之中 Code class Solution: def distributeCoins(self, root: Optional[TreeNode]) -> int: self.res=0 def dfs(node:TreeNode): if node==None: return 0 left=dfs(node.left) right=dfs(node.right) self.res+=abs(left)+abs(right) return right+left+node.val-1 dfs(root) return self.res class Solution { public: int res=0; int dfs(TreeNode* root){ if (!root) return 0; int left=dfs(root->left); int right=dfs(root->right); res+=abs(left)+abs(right); return left+right+root->val-1; } int distributeCoins(TreeNode* root) { dfs(root); return res; } };

↗

题解-困于环中的机器人-模拟与相关证明

思路 对于机器人,如果走结束后方向仍在北方,且不在原点才会脱离圈,不然就会困在圈里 因此只需要模拟即可 证明 假设我们第一次位移结束之后之后机器人所在的坐标为(x,y) 我们按照此时机器人面向的方向讨论 此时面向北方的:下一次前进路线和上次一致,第二次前进之后是(2x,2y),以此类推因此只要x,y不全为0则不会回到原点 此时面向南方: 考虑转换参考系,以面朝的方向为y正半轴,此时两个参考系实际上是180度旋转的,在新参考系下前进了(x,y),并转换了方向,在之前的参考系下,下一次的前进方向与这一次相反,也就是说下一次会移动(-x,-y)的位移,并且下次移动之后会转向北方:与没有动之前一致,进入循环 面向东方:同理,不过是每次都是翻转了90度的方向则位移路径为 (0,0)->(x,y)->(x+y,y-x)->(x+y-x,y-x-y)->(x+y-x-y,y-x-y+x),又到0,且方向回到了北方 面向西方同理 也相当于一个向量乘同一个旋转矩阵和位移矩阵多次但是方向需要另外特判一下 实现思路 用一组数字记录当前坐标 方向只有四种,且每个方向前进的方式不同,所以我们可以用数组存储每一种前进方式,根据方向增加 用一个单独的数字记录当前面向的方向 按照操作,模拟前进方式 判断 代码 class Solution { public: bool isRobotBounded(string instructions) { vector<vector<int>> direction{{0, 1}, {1, 0}, {0, -1}, {-1, 0}}; int x=0,y=0,now_direction=0; for (char choice:instructions){ switch(choice){ case 'G': x+=direction[now_direction][0]; y+=direction[now_direction][1]; break; case 'L': now_direction-=1; if (now_direction<0) now_direction+=4; break; case 'R': now_direction+=1; now_direction%=4; break; default: break; } } return !((x!=0||y!=0)&&now_direction==0); } };

↗

题解-移位字符串分组-哈希表

Problem: 249. 移位字符串分组 思路 类似于凯撒密码的归类方式,我们将所有能通过轮转得到的字符串放在一起,不难想到可以通过暴力来对每一个字符串匹配 对于字符串仔细观察可以发现每一个可以归类到一起的字符串的本质是相同的,不只是字符串长度,还有与左右字母之间的差值 综上,对于每一类字符串我们只需要将其转化为模板的样子就能判断是否能归类 我们的问题就是如何将字符转成一个标准的模板 考虑字符之间的相对关系, 我们设首位为0,后面的每一位对应的是字符串该位与前一位的差 如果小于0则加26,来保证模式字符串相等 解题方法 对于每一个字符串,计算其相对字符的模板字符串 查询哈希表,如果有则插入到相对的答案组中 没有就新开一个答案组 重复上述操作 复杂度 时间复杂度: 只遍历一次 $O(mn)$,m为字符串长度 空间复杂度: 运用了哈希表 $O(n)$ Code class Solution { public: vector<vector<string>> groupStrings(vector<string>& strings) { vector<vector<string>>res; unordered_map<string,int>hash;//模板字符串及其对应的在答案的行数 for (auto &iter:strings){ string tmp="0_"; char a=iter[0]; int now; for (int i=1;i<iter.size();i++){ now=iter[i]-a; if (now<0)//保证模板的一致性 now+=26; tmp+=to_string(now)+"_"; a=iter[i]; } if (hash.find(tmp)!=hash.end()){ res[hash[tmp]].emplace_back(iter); } else{ hash[tmp]=res.size(); res.emplace_back(vector<string>(1,iter)); } } return res; } };

↗

题解-全局倒置和部分倒置-找数学规律

思路 根据题意可知全局倒置包含局部倒置,对于本题如果有 非局部倒置 的全局倒置,则返回false,不然就返回true 很容易相出用暴力去搜索自己2位之后的数组元素中是否有比自己小的,时间复杂度:$O(n^2)$ 倒置是根据的是递增数组出现的,也就是说我们得到的数组实际上是对递增数组进行过几次置换的数组 根据定义可以知道局部倒置的实质就是将相邻的数组元素进行的交换,所以要做的就是与原数组进行比较 位置不变的跳过 位置变化的判断是否和原数组相邻位置的值相等,相等则跳过 不满足上述两个条件的就是全局置换,返回false 代码 class Solution { public: bool isIdealPermutation(vector<int>& nums) { int n=nums.size()-1; int i=0; while (i<n){ if (nums[i]==i) i++; else if (nums[i]==i+1&&nums[i+1]==i) i+=2; else return false; } return true; } };

↗